<template>
  <div class="text-manipulation">
    <div class="content-wrapper">
      <input type="text" v-model="text" @focus="onUndoRedo = false" />
      <span class="item-row output">Output: {{ text }}</span>
      <div class="item-row">
        <button @click="reverse">Reverse</button>
        <button @click="doUndoOrRedo">Unde/Redo</button>
      </div>
    </div>
  </div>
</template>

<script>
export default {
  name: "TextManipulation",
  data() {
    return {
      text: "",
      //I use this history mechanism to do undo and redo
      history: [],
      historyIndex: 0,

      onUndoRedo: false,
      clickCounter: 0,
    };
  },
  methods: {
    //to do reverse the string
    reverse() {
      if (this.text.length > 0) {
        let arr = this.text.split("");
        this.text = arr.reverse().join("");
        //update the history
        this.pushHistory();
      }
    },
    //to decide to do undo or redo based on cliclCounter
    doUndoOrRedo() {
      const chooseAction = () => {
        switch (this.clickCounter) {
          case 1:
            this.undo();
            this.clickCounter = 0;
            break;
          case 2:
            this.redo();
            this.clickCounter = 0;
            break;
          default:
            this.clickCounter = 0;
        }
      };
      this.clickCounter++;
      setTimeout(async () => {
        await chooseAction();
      }, 500);
    },
    //to do undo
    undo() {
      this.onUndoRedo = true;
      this.historyIndex--;
      if (this.historyIndex >= 0) {
        //take the previous array elements
        this.text = this.history[this.historyIndex];
      } else {
        //if the index is already on the first element, keep take the first element
        this.text = this.history[0];
        this.historyIndex = 0;
      }
    },
    //to do redo
    redo() {
      this.onUndoRedo = true;
      this.historyIndex++;
      if (this.historyIndex <= this.history.length - 1) {
        //take the next array elements
        this.text = this.history[this.historyIndex];
      } else {
        //if the index is already on the last element, keep take the last element
        this.text = this.history[this.history.length - 1];
        this.historyIndex = this.history.length - 1;
      }
    },
    //to update input progress to history
    async pushHistory() {
      const setToLastIndex = () => {
        this.historyIndex = this.history.length - 1;
      };
      const setAfterThisIndex = () => {
        this.historyIndex++;
      };
      //I give some delay so the history is not over too filled
      setTimeout(async () => {
        /* This conditional statement is to decide which function will
          be executed based on input position, whether at the last element
          or any position other than that*/
        if (this.historyIndex === this.history.length - 1) {
          if (this.history[this.historyIndex] !== this.text) {
            await this.history.push(this.text);
            await setToLastIndex();
          }
        } else {
          if (this.history[this.historyIndex] !== this.text) {
            await this.history.splice(
              this.historyIndex + 1,
              this.history.length - (this.historyIndex + 1)
            );
            await this.history.push(this.text);
            await setAfterThisIndex();
          }
        }
      }, 1000);
    },
  },
  watch: {
    text(val) {
      //automatically update history while input
      if (val.length > 0) {
        if (!this.onUndoRedo) {
          this.pushHistory();
        }
      } else {
        if (!this.onUndoRedo) {
          this.history.splice(0, this.history.length);
          this.historyIndex = 0;
        }
      }
    },
  },
  mounted() {
    //make the empty condition as the first element of history
    this.history.push(this.text);
  },
};
</script>

<style scoped>
.text-manipulation {
  display: flex;
  flex-direction: row;
  justify-content: center;
}
.content-wrapper {
  display: flex;
  flex-direction: column;
  justify-content: center;
  height: 100%;
  align-items: center;
}
.item-row {
  margin-top: 35px;
}
.output {
  font-size: 40px;
  font-weight: bold;
}
</style>
